it.emasab.Mailclassifier.MailClassifierController = function(accounts){
	this.msgaccount=new Array();
	this.accounts=new Array();
	this.addedFolders=new Array();
	var numServers = accounts.Count();
        var index = 0;
	this.classifyMessage=function(msgURI,account){
		var acc=this.getAccount(account);
		var msg=new it.emasab.Mailclassifier.Message(msgURI);
		if(acc){
			acc.classifyMessage(msg);
		}
	}
	this.forceClassify=function(msgURI,account){
		var acc=this.getAccount(account);
		var msg=new it.emasab.Mailclassifier.Message(msgURI);
		if(acc){
			acc.forceClassify(msg);
		}		
	}
	this.unclassifyMessage=function(msgURI,account){
		var acc=this.getAccount(account);
		if(acc) acc.unclassifyMessage(msgURI);
	}
	
	this.getMoveOnClassification = function(){
		return it.emasab.Mailclassifier.Services.pref.getBoolPref("mailclassifier.preferences.moveOnClassification");
	}
	
	this.getMoveOnClassificationFromDate = function(){
		return it.emasab.Mailclassifier.Services.pref.getCharPref("mailclassifier.preferences.moveOnClassification.fromDate");
	}

	this.isClassificationPresent = function(msgURI){
		var msgHdr = it.emasab.Mailclassifier.Services.messenger.msgHdrFromURI(msgURI);
		var acc=this.msgaccount[msgURI];
		if(!acc){
			acc = this.getAccount(msgHdr.folder.server);
		}
		var classf=acc.getClassificationFor(msgURI);	
		return classf!=null;
	}

	this.getFirstMessageClassification=function(msgURI){		
		var msgHdr = it.emasab.Mailclassifier.Services.messenger.msgHdrFromURI(msgURI);
		if(!it.emasab.Mailclassifier.isInbox(msgHdr.folder)) return null;
		var acc=this.msgaccount[msgURI];
		if(!acc){
			acc = this.getAccount(msgHdr.folder.server);
		}
		var classf=acc.getClassificationFor(msgURI);	
		if(!classf){
			if(it.emasab.Mailclassifier.isInbox(msgHdr.folder)){
				this.classifyMessage(msgURI,acc.mozAccount);
			}			
			return null;		
		}
		var best=classf.getBest();
		var moveOnC = this.getMoveOnClassification();
		if(!best) return null;
		else if(moveOnC){
			var junkscore = msgHdr.getStringProperty("junkscore");
			var moveOnSpam = msgHdr.folder.server.spamSettings.moveOnSpam;
			if(!moveOnSpam || junkscore=="0"){
				var fromDate = null;
				try{
				   	fromDate = this.getMoveOnClassificationFromDate();
										
					if(msgHdr.date.toString() > fromDate){
						folder_src = msgHdr.folder;
						folder_dst = best.mozillaFolder;
						list = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
						list.AppendElement(msgHdr);
						this.unclassifyMessage(msgURI,msgHdr.folder.server);			
						it.emasab.Mailclassifier.Services.copyservice.CopyMessages(folder_src, list, folder_dst , true , null , msgWindow , false );
					}
				}
				catch(e){}				
			}	
		}
		return best.mozillaFolder;
	}
	this.setAccountForURI=function(msgURI,account){
		this.msgaccount[msgURI]=account;
	}
	this.getClassifications=function(msgURI){
		var acc=this.msgaccount[msgURI];
		if(!acc) return null;
		var classf=acc.getClassificationFor(msgURI);
		if(!classf) return null;
		var cfs=classf.getClassifications();
		var ret=new Array();
		for(i=0;i<cfs.length;i++){
			ret.push(cfs[i].uFolder);
		}
		return ret;
	}
	this.getUFolders=function(account){
		var acc=this.getAccount(account);
		if(acc) return acc.getUFolders();
		return null;
	}
	this.addFolder=function(mozFolder){
		var server=mozFolder.server;
		var acc=this.getAccount(server);
		if(acc){
			 acc.addFolderToClassifications(mozFolder);
		}
	}
	this.removeFolder=function(mozFolder){
		var server=mozFolder.server;
		var acc=this.getAccount(server);
		if(acc){
			acc.removeFolderFromClassifications(mozFolder);
		}
	}
	this.changeExcluded=function(mozFolder){
		var acc = this.getAccount(mozFolder.server);
		if(acc) acc.changeExcluded(mozFolder);
	}
	this.getExcluded = function(mozFolder){
		try{
			var acc = this.getAccount(mozFolder.server);
			if(acc) return acc.getExcluded(mozFolder);	
		} catch(e){return false;} 		
	}			
	this.addAccount=function(account){
		if(account!=undefined && account!=null && account.type && account.type=="pop3" || account.type=="imap" 
		|| account.type=="none"){
			var acc=new it.emasab.Mailclassifier.Account(account,this);
			this.accounts[account]=acc;
			return acc;
		}
		return null;
	}
	this.getAccount=function(account){
		var acc=this.accounts[account];
		if(acc) return acc;
		return this.addAccount(account);
	}

	this.getAccounts = function(){
		return this.accounts	
	}

	this.removeAccount=function(account){

	}
	this.update=function(msgURI,mozFolder){
		
	}
	this.shutdown=function(){
		for (var i= 0; i < this.accounts.length; i++){
			this.accounts[i].shutdown();
		}		
	}
	
	this.writeData = function(){
		for(acc in this.accounts){
			var account = this.accounts[acc];
			account.writeData();
		}
	}
	
	this.resetTrainingData = function(account){
		var account = this.getAccount(account)
		if(account){
			account.resetTrainingData();
		}
	}

	this.setClassification=function(msgURI,folder){
		dump("setClassification: " + uri + "," + folder.name + "\n");
		var acc=this.accounts[folder.server];
		if(acc){
			acc.setClassification(msgURI,folder);
		}
	}
	for (index = 0; index < numServers; index++){
		var currentServer = accounts.GetElementAt(index).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
		this.addAccount(currentServer);
	}
}
